moSetGetStationes = {};

function moSetGetStationes:setFirstStationTriggers(self, updateNewNames)	
	moStationes = {};
	--moStationesTemp = {};
	--moStationesSort = {};
	moGeneralSettings.mapStations = 0;
	moBGA = {};
	moBGA.fill = 0;	
	--moBGATrigger = {};	
	local triggerNumber = 1;
	local farmSilo = moGeneralSettings.multiFarmSilo;
	local hofSilo01 = false;
	for a, tipTrigger in pairs(g_currentMission.tipTriggers) do
		local stationName = getUserAttribute(tipTrigger.triggerId, "stationName");				
		local isAreaTrigger = Utils.getNoNil(getUserAttribute(tipTrigger.triggerId, "isAreaTrigger"), false);
		local isFarmTrigger = Utils.getNoNil(getUserAttribute(tipTrigger.triggerId, "isFarmTrigger"), false);
		local siloName = getName(tipTrigger.triggerId);	
		local id = tipTrigger.triggerId;		
		if stationName ~= nil and tipTrigger.appearsOnPDA then
			if tipTrigger.priceMultipliers ~= nil and tipTrigger.acceptedFillTypes ~= nil then				
				local textName = stationName;
				if g_i18n:hasText(stationName) then
					textName = g_i18n:getText(stationName);				
				end;
				local checkLeerName = stationName;
				if string.find(stationName, " ") then
					checkLeerName = string.gsub(stationName, " ", "_");
				end;
				local languageStationName = moLanguageXml:getTxt("station_".. string.lower(checkLeerName));
				if languageStationName ~= "L Error" and languageStationName ~= "L Missing" then
					if tipTrigger.mapHotspot.fullViewName ~= nil then tipTrigger.mapHotspot.fullViewName = languageStationName;end;
					textName = languageStationName;
				end;
				local foundTrain = false;
				if tipTrigger.updateEventListeners ~= nil then
				--if stationName == "StationFreightYard" then									
					for key, value in pairs(tipTrigger.updateEventListeners) do
						if foundTrain then break;end;						
						for key1, value1 in pairs(value) do
							if key1 == "train" then	foundTrain = true;moGeneralSettings.trainStationFound = true;break;end;							
						end;
					end;
				end;
				--if foundTrain then textName = textName.. "(+".. tostring(moLanguageXml:getTxt("train", nil, "Train")).. ")";end;
				local lengthName = string.len(textName);				
				if lengthName > moGeneralSettings.lengthStationName then moGeneralSettings.lengthStationName = lengthName;end;
				--moGeneralSettings.lengthStation = moGeneralSettings.lengthStation+lengthName+3;
				moGeneralSettings.mapStations = moGeneralSettings.mapStations+1;
				moStationes[stationName] = {};
				--if stationName == "BGA_Station_name" then
				--	moBGATrigger[bga] = {};					
				--	moBGATrigger[bga].bgaTrigger = tipTrigger;					
				--	bga = bga+1;
				--end;
				--if stationName ~= "BGA_Station_name" and string.find(string.lower(stationName), "bga") then
				--	moBGATrigger[bga] = {};					
				--	moBGATrigger[bga].bgaTrigger = tipTrigger;					
				--	bga = bga+1;
				--end;
				--table.insert(moStationesSort, stationName);
				local x,y,z = getWorldTranslation(tipTrigger.rootNode);				
				moStationes[stationName].x = x;
				moStationes[stationName].z = z;				
				moStationes[stationName].station = stationName;
				moStationes[stationName].stationName = textName;
				moStationes[stationName].stationNameLength = lengthName;
				moStationes[stationName].acceptedFillTypes = tipTrigger.acceptedFillTypes;
				moStationes[stationName].priceMultipliers = tipTrigger.priceMultipliers;
				moStationes[stationName].greatDemand = false;
				moStationes[stationName].greatDemandFruit = "";
				moStationes[stationName].greatDemandMultiplier = 1;
				moStationes[stationName].greatDemandDuration = 0;
				moStationes[stationName].firstLetter = 0;
				moStationes[stationName].isTrain = foundTrain;
				moStationes[stationName].close = false;
				moStationes[stationName].insolvenz = false;
				moStationes[stationName].shares = {};
				moStationes[stationName].tipTrigger = tipTrigger;
			end;
		elseif not hofSilo01 then --unLoad	
			if isFarmTrigger and isAreaTrigger and siloName ~= nil and siloName == "grainStationTrigger" then
				if tipTrigger.acceptedFillTypes ~= nil then																		
					local fillTypes = getUserAttribute(tipTrigger.triggerId, "fillTypes");									
					if fillTypes == nil then
						fillTypes = getUserAttribute(tipTrigger.triggerId, "fruitTypes");
					end;
					if string.find(fillTypes, "wheat ") ~= nil then							
						if string.len(moGeneralSettings.multiFarmSiloUnLoad) > 1 then
							moGeneralSettings.multiFarmSiloUnLoad = moGeneralSettings.multiFarmSiloUnLoad.. " ";
						else
							moGeneralSettings.multiFarmSiloUnLoad = fillTypes.. " ";
						end;
						local fillTypesSplit = Utils.splitString(" ", moGeneralSettings.multiFarmSiloUnLoad);						
						for k,v in pairs(fillTypesSplit) do
							local desc = Fillable.fillTypeNameToDesc[v];
							if desc ~= nil and tipTrigger.acceptedFillTypes[desc.index] == nil then
								moFillTypes[desc.index].siloUnLoad[farmSilo] = true;
								if not MultiOverlayV2.isMp then
									tipTrigger.acceptedFillTypes[desc.index] = true;
								end;
							elseif desc ~= nil then
								moFillTypes[desc.index].siloUnLoad[farmSilo] = true;
							end;						
						end;							
						hofSilo01 = true;
						if moMapTrigger == nil then moMapTrigger = {};end;
						moMapTrigger["hofSiloUnLoad"] = tipTrigger;
					end;						
				end;					
			end;
		end;		
	end;
	--function compare(a,b)
	--	return a[1] < b[1];
	--end
	--table.sort(moStationesSort, compare);	
	--function getKeysSortedByValue(tbl, sortFunction)
	--	local keys = {};
	--	for key in pairs(tbl) do
	--		table.insert(keys, key);
	--	end;
	--	table.sort(keys, function(a, b)
	--		return sortFunction(tbl[a], tbl[b])
	--	end)
	--	return keys;
	--end
	--local sortedKeys = getKeysSortedByValue(moStationesSort, function(a, b) return a < b end);	
	--for _, key in ipairs(sortedKeys) do
	--	local stationName = moStationesSort[key];
		--moStationes[stationName] = {};
	--	table.insert(moStationes[stationName], moStationesTemp[stationName]);
	--	print(key, moStationesSort[key])
	--end;	
	--table.remove(moStationesTemp);
	--table.remove(moStationesSort);	
end;

function moSetGetStationes:setStationUpdate(self, all, train)	
	moBGA.fill = 0;	
	if all then
		for a=1, Fillable.NUM_FILLTYPES do			
			local desc = Fillable.fillTypeIndexToDesc[a];
			if desc ~= nil and desc.name ~= "choppedStraw" and desc.name ~= "choppedMaize" and desc.name ~= "choppedRape" and desc.name ~= "choppedMaize_haulm" and desc.name ~= "choppedStraw_haulm" and desc.name ~= "choppedRape_haulm" then		
				if moFillTypes[desc.index] ~= nil then ----Anpassung an Mods made by HappyLooser----
					moFillTypes[desc.index].bestPrice = 0;
					moFillTypes[desc.index].bestPriceStation = "";
					moFillTypes[desc.index].greatDemandStation = nil;
					moFillTypes[desc.index].greatDemandStationDescName = nil;
					moFillTypes[desc.index].greatDemandMultiplier = 1;
					moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter,0);
					moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice,0);					
					moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);
					moFillTypes[desc.index].moneyTotal = 0;
					moFillTypes[desc.index].stationPriceMulti = {};
					moFillTypes[desc.index].stationPriceMultiChange = {};
				end;
				----bestPrice Total----
				if Fillable.fillTypeIndexToDesc[a].partOfEconomy ~= nil and Fillable.fillTypeIndexToDesc[a].partOfEconomy and moFillTypes[desc.index] ~= nil or desc.name == "silage" then				
					local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(a);
				end;
				----bestPrice Total----				
			end;
		end;		
	end;	
	for a, tipTrigger in pairs(g_currentMission.tipTriggers) do
		local stationName = getUserAttribute(tipTrigger.triggerId, "stationName");		
		if stationName ~= nil and moStationes[stationName] ~= nil and tipTrigger.appearsOnPDA then
			if tipTrigger.priceMultipliers ~= nil and tipTrigger.acceptedFillTypes ~= nil then				
				local fillTypes = "";
				if all then
				----Anpassung an Mods made by HappyLooser----
					for k,v in pairs(tipTrigger.acceptedFillTypes) do
						local desc = Fillable.fillTypeIntToName[k];						
						local descIndex = Fillable.fillTypeIndexToDesc[desc];
						if desc ~= nil and tipTrigger.acceptedFillTypes[k] then
							fillTypes = fillTypes.. desc.. " "
							--if descName ~= nil and moFillTypes[descName.index] ~= nil then
								--print("eintragen ".. stationName)
								--moFillTypes[desc].stationPriceMulti[stationName.. "PriceMulti"] = tipTrigger.priceMultipliers[desc];
							--end;
						end;
					end;
					moStationes[stationName].acceptedFillTypes = fillTypes;
				else
					fillTypes = moStationes[stationName].acceptedFillTypes;
				end;				
				----Anpassung an Mods made by HappyLooser----				
				local types = Utils.splitString(" ", fillTypes);
				local greatDemand = false;				
				for i, nameFruit in pairs(types) do
					local desc = Fillable.fillTypeNameToDesc[nameFruit];
					if desc ~= nil and desc.name ~= "choppedStraw" and desc.name ~= "choppedMaize" and desc.name ~= "choppedRape" and desc.name ~= "choppedMaize_haulm" and desc.name ~= "choppedStraw_haulm" and desc.name ~= "choppedRape_haulm" then						
						---best price
						local trainPriceMulti = 1;
						if moGeneralSettings.isTrainPrice and moStationes[stationName].isTrain then trainPriceMulti = moGeneralSettings.trainPriceMulti;end;
						local priceMulti = Utils.getNoNil(tipTrigger.priceMultipliers[desc.index], 0)*trainPriceMulti;						
						local checkOldPriceMulti = moFillTypes[desc.index].bestPrice;
						if priceMulti > checkOldPriceMulti then
							moFillTypes[desc.index].bestPrice = Utils.getNoNil(tipTrigger.priceMultipliers[desc.index], 0)*trainPriceMulti;
							moFillTypes[desc.index].bestPriceStation = moStationes[stationName].stationName;
							moFillTypes[desc.index].x = moStationes[stationName].x;
							moFillTypes[desc.index].z = moStationes[stationName].z;
						end;						
						---best price
						moFillTypes[desc.index].stationPriceMulti[stationName.. " PriceMulti"] = Utils.getNoNil(tipTrigger.priceMultipliers[desc.index], 0)*trainPriceMulti;
						moFillTypes[desc.index].stationPriceMultiChange[stationName.. " PriceMulti"] = Utils.getNoNil(tipTrigger.priceMultipliers[desc.index], 0);
						moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter, 0);						
						moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice,0);
						if tonumber(moFillTypes[desc.index].pricePerLiter) < tonumber(moFillTypes[desc.index].previousHourPrice) then
							moFillTypes[desc.index].stateHourPrice = 2; --down							
						elseif tonumber(moFillTypes[desc.index].pricePerLiter) > tonumber(moFillTypes[desc.index].previousHourPrice) then
							moFillTypes[desc.index].stateHourPrice = 1; --up							
						else
							moFillTypes[desc.index].stateHourPrice = 0; --equal							
						end;
						moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);						
						local demand = g_currentMission.economyManager:getCurrentGreatDemand(tipTrigger.stationName, desc.index);						
						local greatDemandMultiplier = 1;
						if demand ~= nil and demand.isRunning then
							greatDemand = true;
							if not moStationes[stationName].greatDemand then
								moGeneralSettings.foundGreatDemand = moGeneralSettings.foundGreatDemand+1;
							end;
							moStationes[stationName].greatDemand = true;
							moFillTypes[desc.index].greatDemandStation = moStationes[stationName].stationName;
							moFillTypes[desc.index].greatDemandStationDescName = stationName;
							moFillTypes[desc.index].x = moStationes[stationName].x;
							moFillTypes[desc.index].z = moStationes[stationName].z;
							greatDemandMultiplier = demand.demandMultiplier;
							moFillTypes[desc.index].greatDemandMultiplier = demand.demandMultiplier;
							moStationes[stationName].greatDemandDuration = demand.demandDuration; ---active test, DrawWarnings														
							moStationes[stationName].greatDemandMultiplier = demand.demandMultiplier;
							local demandFruits = moStationes[stationName].greatDemandFruit;
							if string.find(demandFruits, nameFruit.. " ") == nil then
								moStationes[stationName].greatDemandFruit = moStationes[stationName].greatDemandFruit.. nameFruit.. " ";
							end;						
						end;						
					end;
				end;
				for k,v in pairs(moFillTypes) do
					if moFillTypes[k].stationPriceMultiChange[stationName.. " PriceMulti"] == nil then
						moFillTypes[k].stationPriceMultiChange[stationName.. " PriceMulti"] = 0.00;
					end;
				end;
				if not greatDemand then
					if moStationes[stationName].greatDemand then
						moGeneralSettings.foundGreatDemand = moGeneralSettings.foundGreatDemand-1;
					end;
					moStationes[stationName].greatDemand = false;					
					moStationes[stationName].greatDemandMultiplier = 1;
					moStationes[stationName].greatDemandDuration = 0;
					moStationes[stationName].greatDemandFruit = "";
				end;
				moStationes[stationName].tipTrigger = tipTrigger;
			end;
		else
			if tipTrigger.bunkerSilo ~= nil and tipTrigger.bunkerSilo.state == 2 then
				moBGA.fill = moBGA.fill+math.ceil(tipTrigger.bunkerSilo.fillLevel);								
			end;
			if stationName ~= nil and moStationes[stationName] ~= nil and not tipTrigger.appearsOnPDA then
				moStationes[stationName].close = true; ----Anpassung an Mods made by HappyLooser----
			end;			
		end;
	end;	
end;

function moSetGetStationes:setStationsMaxProSwitch(self)	
	local station = moGeneralSettings.mapStations/moSetGetGui.page[1].maxStationsProSwitch;
	local maxSwitch = moSetGetGui:round(station+0.5);	
	if maxSwitch < 1 then maxSwitch = 1;end;
	moSetGetGui.page[1].maxStationsSwitch = maxSwitch;	
	if moSetGetGui.page[1].stationsSwitch > maxSwitch then moSetGetGui.page[1].stationsSwitch = 1;end;
end;

function moSetGetStationes:setFirstEndStations(self)	
	if moSetGetGui.page[1].stationsSwitch == 1 then moSetGetGui.page[1].firstStation = 1;moSetGetGui.page[1].endStation = moSetGetGui.page[1].maxStationsProSwitch;end;
	if moSetGetGui.page[1].stationsSwitch > 1 then moSetGetGui.page[1].firstStation = (moSetGetGui.page[1].stationsSwitch-1)*moSetGetGui.page[1].maxStationsProSwitch+(1);moSetGetGui.page[1].endStation = moSetGetGui.page[1].stationsSwitch*moSetGetGui.page[1].maxStationsProSwitch;end;
	if moSetGetGui.page[1].endStation > moGeneralSettings.mapStations then moSetGetGui.page[1].endStation = moGeneralSettings.mapStations;end;
end;